//
// fonde sur openGL:    www.demonews.com/hosted/nehe Jeff Molofee '99
// et aussi sur     http://www.xmission.com/~nate/tutors.html
//
/**************************************************************/
// 
// 
//  
// 29 septembre 2004  ---- 15 octobre 2004
//cc -ffast-math   -framework GLUT -framework OpenGL -lobjc mainRDV.c RDV.c glm.c -o ../rdvs
//record pyl 60
//cc  -Wall -no-cpp-precomp -I/usr/X11R6/include -L/usr/X11R6/lib -lGL -lGLU -lglut -lX11 -lXmu -lm *.c -o ../rdvs

#if defined(__APPLE__) && !defined(__APPLE_X11)
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include "math.h"
#include <string.h>   //utile pour strings
#include <stdarg.h>   //utile pour drawstr
#include "glm.h"
//G4 9.6; Compac Evo410c (PIII 1.2GHz) 8.05; DELL Lat D600 42.55; G5 60.8;
 
// Constants -----------------------------------------------------------------
#include "tete_RDV.h"
#define kWindowWidth	800
#define kWindowHeight	800
 
// Function Prototypes -------------------------------------------------------

GLvoid InitGL(GLvoid);
GLvoid DrawGLScene(GLvoid);
GLvoid ReSizeGLScene(int Width, int Height);
GLvoid Keyboard(unsigned char key, int x, int y);
  void GlutLoop(int * , char**);
GLMmodel* pmodel = NULL;
GLMmodel* pmodel2 = NULL;
  parametres para_phy; 

// Main ----------------------------------------------------------------------
float spin_x = -35;
float spin_y = -45;  //45
float sdepth =  35;
float sdepth27= 45;

    GLfloat pos[] = { 1.0, 1.0, 5.0, 0.0 };
    GLfloat lKa[] = { 0.4, 0.4, 0.4, 1.0 };
    GLfloat lKd[] = { 0.3, 0.3, 0.3, 1.0 };
    GLfloat lKs[] = { 0.2, 0.2, 0.2, 1.0 };
int old_x, old_y;
int rot=1,look=1;
int help=0,pause=0;
int coll=0;
double* x=NULL,* y=NULL,* z=NULL;
double X=0,Y=0,Z=0,Xp=0,Yp=0,Zp=0;
double px=0,py=0,pz=0;
int pcmax=150,pc;
int slow=8;
double t=0,speed=1,tcalc=0.05;  
int it_t;
//char  ici[256],fic[256];
char *ici,*nomfichier,*nomcible,*nomchasseur;
int mainMenu;
void  raz();
void  MateriauP();
void  MateriauB();
void  init(int * , char**);
// ------
void  MateriauP()
{GLfloat  material_Ka_P []  = { .99f, 0.0f  , .0f, 1.0f };
 GLfloat  material_Kd_P []  = { .99f, 0.0f  , .0f, 1.0f };
 GLfloat  material_Ks_P []  = { .99f, 0.f  , .0f, 1.f };
 GLfloat  material_Ke_P []  = { .0f, 0.0f  , 0.0f, 1.f };
 GLfloat  material_Se_P []  = { 28. };
    glMaterialfv(GL_FRONT, GL_AMBIENT , material_Ka_P);
    glMaterialfv(GL_FRONT, GL_DIFFUSE , material_Kd_P);
    glMaterialfv(GL_FRONT, GL_EMISSION, material_Ke_P);
    glMaterialfv(GL_FRONT, GL_SPECULAR, material_Ks_P); 
    glMaterialfv(GL_FRONT, GL_SHININESS, material_Se_P);
}  
void  MateriauB()
{GLfloat  material_Ka_P []  = { 0.f, 0.0f , .99f, 1.0f };
 GLfloat  material_Kd_P []  = { 0.f, 0.0f , .9f, 1.0f };
 GLfloat  material_Ks_P []  = { 0.f, 0.f  , .9f, .6f };
 GLfloat  material_Ke_P []  = { .0f, 0.f  , 0.1f, 0.f };
 GLfloat  material_Se_P []  = { 28. };
    glMaterialfv(GL_FRONT, GL_AMBIENT , material_Ka_P);
    glMaterialfv(GL_FRONT, GL_DIFFUSE , material_Kd_P);
    glMaterialfv(GL_FRONT, GL_EMISSION, material_Ke_P);
    glMaterialfv(GL_FRONT, GL_SPECULAR, material_Ks_P); 
    glMaterialfv(GL_FRONT, GL_SHININESS, material_Se_P);
}

void  MateriauT()
{GLfloat  material_Ka_P []  = { 0.f, 0.2f , 1.f, 1.0f };
 GLfloat  material_Kd_P []  = { 0.f, 0.2f , .9f, 1.0f };
 GLfloat  material_Ks_P []  = { 0.f, 0.2f  , .9f, .6f };
 GLfloat  material_Ke_P []  = { .0f, 0.f  , 0.0f, 0.f };
 GLfloat  material_Se_P []  = { 28. };
    glMaterialfv(GL_FRONT, GL_AMBIENT , material_Ka_P);
    glMaterialfv(GL_FRONT, GL_DIFFUSE , material_Kd_P);
    glMaterialfv(GL_FRONT, GL_EMISSION, material_Ke_P);
    glMaterialfv(GL_FRONT, GL_SPECULAR, material_Ks_P); 
    glMaterialfv(GL_FRONT, GL_SHININESS, material_Se_P);
}  
void  MateriauT2()
{GLfloat  material_Ka_P []  = { 0.7f, 0.7f , 1.0f, 1.0f };
 GLfloat  material_Kd_P []  = { 0.7f, 0.7f , 0.9f, 1.0f };
 GLfloat  material_Ks_P []  = { 0.0f, 0.2f , 0.9f, .6f };
 GLfloat  material_Ke_P []  = { 0.0f, 0.f  , 0.0f, 0.f };
 GLfloat  material_Se_P []  = { 28. };
    glMaterialfv(GL_FRONT, GL_AMBIENT , material_Ka_P);
    glMaterialfv(GL_FRONT, GL_DIFFUSE , material_Kd_P);
    glMaterialfv(GL_FRONT, GL_EMISSION, material_Ke_P);
    glMaterialfv(GL_FRONT, GL_SPECULAR, material_Ks_P); 
    glMaterialfv(GL_FRONT, GL_SHININESS, material_Se_P);
} 
void  MateriauN()
{GLfloat  material_Ka_P []  = { 0.3f, 0.3f , 0.3f, 1.0f };
 GLfloat  material_Kd_P []  = { 0.3f, 0.3f , 0.3f, 1.0f };
 GLfloat  material_Ks_P []  = { 0.3f, 0.2f  ,0.2f, .6f };
 GLfloat  material_Ke_P []  = { .0f, 0.f  , 0.0f, 0.f };
 GLfloat  material_Se_P []  = { 28. };
    glMaterialfv(GL_FRONT, GL_AMBIENT , material_Ka_P);
    glMaterialfv(GL_FRONT, GL_DIFFUSE , material_Kd_P);
    glMaterialfv(GL_FRONT, GL_EMISSION, material_Ke_P);
    glMaterialfv(GL_FRONT, GL_SPECULAR, material_Ks_P); 
    glMaterialfv(GL_FRONT, GL_SHININESS, material_Se_P);
} 
// affichage texte

void 
drawstr18(double x, double y, char* format, ...)
{   va_list args;
    char buffer[255], *s;
    va_start(args, format);
    vsprintf(buffer, format, args);
    va_end(args);
    glRasterPos3f(x, y, 0);
    //glRasterPos2i(x, y);
    for (s = buffer; *s; s++)
        glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *s); //12
}
void 
drawstr12(double x, double y, char* format, ...)
{   va_list args;
    char buffer[255], *s;
    va_start(args, format);
    vsprintf(buffer, format, args);
    va_end(args);
    glRasterPos3f(x, y,0);
    for (s = buffer; *s; s++)
        glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *s); 
}
// souris vue ------------------------------------------------------------
void
mouse(int button, int state, int x, int y)
{ //if ((button == GLUT_LEFT_BUTTON) && (state == GLUT_DOWN)) { 
  //} else if ((button == GLUT_LEFT_BUTTON) && (state == GLUT_UP)) {
    old_x = x;
    old_y = y;
   glutPostRedisplay();
}
void
motion(int x, int y)
{
  spin_x += x - old_x;
  spin_y += y - old_y; 
    old_x = x;
    old_y = y; 
  glutPostRedisplay();
}


// ReSizeGLScene ------------------------------------------------------------
GLvoid ReSizeGLScene(int Width, int Height)
{
    glViewport (0, 0, (GLsizei) Width, (GLsizei) Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0, (GLfloat) Width / (GLfloat) Height, 0.1, 100.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
// clavier  ------------------------------------------------------------
void Keyboard(unsigned char key, int x, int y)
{extern  parametres para_phy;
 static double Omo=-1;
 static int flag=0;
  
// printf("key\n"); 
 switch(key)
{                 
case 'F':	
 glutFullScreen();
break;  

case 'f':	
// ReSizeGLScene(400,400);
  //glutReshapeFunc(ReSizeGLScene); 
break; 

case 'k':
 Omo=-1;
 raz();
break; 
  
case 'h':
  if(help==1){help=0;}else{
     system("open -a Safari data/aide.html");
     help=1;};
break;   

case 'p':  //pause
  if(!pause){pause=1;}else{pause=0;}
break; 

case 'l':  //look at
  if(look==0){look=1;}else{look=0;}
break; 

case 'o': // "o" on enleve Omega
  if((Omo<0)&&(flag==0)){
  Omo=para_phy.Omega;
  para_phy.Omega=0;
  flag=0;
      }  
break;
  
case 'O': // "O" on met Omega
  if(Omo>0){
  para_phy.Omega=Omo;
  Omo=-1;
      }  
break;
  

case 's':  // "s" plus lent
//speed=speed/2;
//para_phy.dt=para_phy.dt/2;
//printf("%lf\n",speed);
slow=slow+2;
break; 

case 'S': // "S" plus vite	
//speed=speed*2;
//para_phy.dt=para_phy.dt*2;printf("%lf\n",speed);
slow=slow-2;
if (slow<1)slow=1;
break; 

case 'r':		// control 
 rot= 1; 
break;
               
case 't':		// control 
 rot= 0;		 
 spin_x = 0;
 spin_y =0;
break;

case 'v':		// vue de dessus 
 look=0;rot =1; spin_x = 0; spin_y =0; sdepth = sdepth27;
break;

case '+': sdepth += 2.0; break;
case '-': sdepth -= 2.0; break;
case 27:  printf("kenavo ! \n");exit(0); break;

case 'Q':
 printf("kenavo ! \n"); exit(EXIT_SUCCESS);
break;                  

default:
break;                
	}
}
//-----
void parsekey_special(int key, int x, int y)
{extern  parametres para_phy;
 extern int pc;
//printf("%d\n",key);

switch(key){  //p .2
        case GLUT_KEY_UP:	py += para_phy.p; pc--; break;
	case GLUT_KEY_DOWN:	py -= para_phy.p; pc--; break;
        case GLUT_KEY_RIGHT:	px += para_phy.p; pc--; break;
        case GLUT_KEY_LEFT:	px -= para_phy.p; pc--; break;
        case GLUT_KEY_PAGE_UP:  pz += para_phy.p; pc--; break;
        case GLUT_KEY_PAGE_DOWN:pz -= para_phy.p; pc--; break;   //noter le 10
        case GLUT_KEY_HOME:     sdepth -= 2.0;; break;
        case GLUT_KEY_END:      sdepth += 2.0;; break; 
            } 
}
//-----
void M_menu_select(int mode)
{
       switch (mode) {
       case 0: printf("0\n");nomfichier="data/fo.in"; raz(); break;
       case 1: printf("1\n");nomfichier="data/fo1.in";raz(); break;
       case 2: printf("2\n");nomfichier="data/fo2.in";raz(); break;
       case 3: printf("3\n");nomfichier="data/fo3.in";raz(); break;
       case 4: printf("4\n");nomfichier="data/fo4.in";raz(); break;
       case 5: printf("5\n");nomfichier="data/fo5.in";raz(); break;
       }
}
//---- 
void M_model_select(int mode)
{
       switch (mode) {
       case 0: pmodel2 = NULL;pmodel = NULL;
       nomchasseur="data/gemini_final.obj";nomcible="data/geminiB.obj"; break;
       case 1: pmodel2 = NULL;pmodel = NULL;
       nomchasseur="data/apolloRDV.obj";nomcible="data/soyouz_0.obj"; break;
       case 2: pmodel2 = NULL;pmodel = NULL;
       nomchasseur="data/soyouz_0.obj";nomcible="data/apolloRDV.obj"; break;
       case 3: pmodel2 = NULL;pmodel = NULL;
       nomchasseur="data/chasseur.obj";nomcible="data/cible.obj"; break;
       case 4: printf("4\n");nomfichier="data/fo4.in";raz(); break;
       case 5: printf("5\n");nomfichier="data/fo5.in";raz(); break;
       }
}
//----                 
void setMain(int value)
{
    switch(value) 
    {
        case 0:  spin_x=-35;spin_y=-45;rot=1;look=0;
                 sdepth=35;t=0;nomfichier="data/fo.in";raz();break;
        case 1:  rot=1; look=0; break;
        case 2:  rot=0; look=0; spin_y=45; spin_x=0;  break; 
        case 3:  raz();  break;
        case 4:  look=0;rot =1; spin_x = 0; spin_y =0; sdepth = sdepth27;  break;
        case 5:  if(look==0){look=1;}else{look=0;}  break;
        case 6:  if(help==1){help=0;}else{system("open -a Safari data/aide.html");help=1;} break;
        case 7:  exit(0);   break;
    }
}
// Init ----------------------------------------------------------------------
GLvoid InitGL(GLvoid)
{

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
	glClearDepth(1.0);				// Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);				// The Type Of Depth Test To Do
	glEnable(GL_DEPTH_TEST);			// Enables Depth Testing
	glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading
        glFrontFace(GL_CCW);
        glCullFace(GL_FRONT);
        glMatrixMode(GL_PROJECTION);
	glLoadIdentity();							// Reset The Projection Matrix
	gluPerspective(45.0f,(GLfloat)kWindowWidth/(GLfloat)kWindowHeight,0.1f,100.0f);	
        // Calculate The Aspect Ratio Of The Window
	glMatrixMode(GL_MODELVIEW);
  
  
   
  //glMultMatrixd(inverse);
  glLightfv(GL_LIGHT0, GL_POSITION, pos);
  glLightfv(GL_LIGHT0, GL_AMBIENT,  lKa);//
  glLightfv(GL_LIGHT0, GL_DIFFUSE,  lKd);//
  glLightfv(GL_LIGHT0, GL_SPECULAR, lKs);//
 
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING); 
 
}
//----------------------------------------------------
void
drawmodel2(double x,double y,double z)
{ extern double t;
  extern char *nomcible;
  static float Rt=50,cT=30;// 400 45
  glPushMatrix();
   glTranslatef(x, y,z);
      glRotatef(90, 1, 0, 0);
     // glRotatef(180, 0, 1, 0);
    if (!pmodel2) {
        pmodel2 = glmReadOBJ(nomcible);//soyouz_0.obj
        if (!pmodel2) exit(0);
        glmUnitize(pmodel2);
        glmFacetNormals(pmodel2);
        glmVertexNormals(pmodel2, 90.0);
    }
    glmDraw(pmodel2, GLM_SMOOTH | GLM_MATERIAL);
    glTranslatef(x-Rt-cT, y,z);//150
    MateriauT(); 
    glutSolidSphere(Rt,48,48);
    MateriauT2(); 
    glRotatef(90,1,0,0);//glRotatef(90,0,1,0); H->D
    //glRotatef(90,1,0,0);
    //glRotatef(90,1,0,0);//glRotatef(-1*t, 0, 1, 0);
    glRotatef(10*t, 0, 0, 1);  //
    glutWireSphere(Rt+1,24,24);
    glPopMatrix(); 
}
//-----------------------------------------------------
void
drawmodel(double x,double y,double z)
{extern char *nomchasseur;
  glPushMatrix();
   glTranslatef(x, y,z);
      glRotatef(90, 1, 0, 0);
      glRotatef(180, 0, 1, 0);
      glScalef(1,1,1);
    if (!pmodel) {
        pmodel = glmReadOBJ(nomchasseur);//gemini_final.obj
        if (!pmodel) exit(0);
        glmUnitize(pmodel);
        glmFacetNormals(pmodel);
        glmVertexNormals(pmodel, 90.0);
    }
    glmDraw(pmodel, GLM_SMOOTH | GLM_MATERIAL);
   glPopMatrix(); 
}
void drawpouss(double x,double y,double z)
{
  glPushMatrix();
  glTranslatef(x, y,z);
  glPopMatrix();
}

void lamp()
{   glLightfv(GL_LIGHT0, GL_POSITION, pos);
    glLightfv(GL_LIGHT0, GL_AMBIENT, lKa);//
    glLightfv(GL_LIGHT0, GL_DIFFUSE, lKd);//
    glLightfv(GL_LIGHT0, GL_SPECULAR, lKs);//
}
// jauge aide
void aide(double x,double y,double z,double xp,double yp,double zp)   // affichage d'aide et de commentaire
{ extern int pc,help,coll;
  double v,dist,res;
  extern double t;
  lamp();
  v=  pow(xp*xp+yp*yp+zp*zp,.5);
  dist=pow(x*x+(y+1)*(y+1)+z*z,.5);
  res =pc*1.0;
    glPushMatrix();   
    glTranslatef(0, 0,0);
    MateriauP();  
    if(help==1){
     drawstr12(-1,-1.50,"pour avancer: fl`eche avant, aller `a droite fl`eche droite, reculer fl`eche gauche, etc");
     drawstr12(-1,-1.75,"pageUp, pageDown: monter, descendre");
     drawstr12(-1,-2.00,"k: remet `a z'ero le calcul");
     drawstr12(-1,-2.25,"l: vue du chasseur/ vue du paysage");
     drawstr12(-1,-2.50,"p: pause/go");
     drawstr12(-1,-2.75,"esc: pour quitter");
     drawstr12(-1,-3.00,"h: aide/ pas d'aide");
      }
    drawstr12(-4,-4,
    "www.lmm.jussieu.fr/~lagree *   pyl@ccr.jussieu.fr *** 10/04 *** Clic droit: modification de la simulation et de la vue ** *");
    drawstr18(-3.5,3.9,
    "temps = %7.3lf vitesse = %6.3lf distance = %7.3lf reserve  = %4.2lf",t,v,dist,res) ;
    drawstr18(-3.5,3.6,"x  = %7.3lf y  = %7.3lf z  = %7.3lf ",x,y,z) ;
    drawstr18(-3.5,3.3,"xp= %7.3lf yp= %7.3lf zp= %7.3lf ",xp,yp,zp) ;
     if(coll==1){ drawstr18(-2,3,"collision, perdu.       Appuyer sur 'k' pour recommencer") ; }
     if(coll==2){ drawstr18(-2,3,"Arrimage OK, trop vite. Appuyer sur 'k' pour recommencer") ; }
     if(coll==3){ drawstr18(-2,3,"Arrimage OK, gagn'e.    Appuyer sur 'k' pour recommencer") ; }
     if(coll==4){ drawstr18(-2,3,"Perdu dans l'espace.    Appuyer sur 'k' pour recommencer") ; }
     //MateriauB(); 
    glPopMatrix();  }
    
void drawjau(double xp,double yp,double zp)
{ extern  parametres para_phy;
  extern int pc;
  double v;
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    lamp();
    v=pow(xp*xp+yp*yp+zp*zp,.5);
     glTranslatef(0.0,0.0,-10); 
     glPushMatrix();
     if(pc<0){pc=0;para_phy.p=0;}
//glColor3ub(255, 0, 0);
MateriauP(); 
 glBegin(GL_POLYGON); 
  glVertex3f(-4.15,-3,0);
  glVertex3f(-4.15,pc/30.-3,0);
  glVertex3f(-4 ,pc/30.-3,0);
  glVertex3f(-4,0-3,0);
 glEnd();
 
  MateriauB(); 
  glBegin(GL_POLYGON);
  //printf("%d %lf\n",pc,para_phy.p);
  glVertex3f(-4,-3,0);
  glVertex3f(-4, v-3.,0);
  glVertex3f(-3.85 ,v-3.,0);
  glVertex3f(-3.85,0-3,0);
 glEnd();
  MateriauB(); 
 glBegin(GL_POLYGON);
  glVertex3f(-3.85,-3,0);
  glVertex3f(-3.85, .12-3.,0);
  glVertex3f(-3.7 ,.12-3.,0);  //vmax 0.12
  glVertex3f(-3.7,0-3,0);
 glEnd();
 glPopMatrix(); 
}
//-----------------------------------------------------
void
collision(double x,double y,double z,double xp,double yp,double zp)
{//test la collision
 extern double tcalc;
 extern int coll;
 double v;
 v=pow(xp*xp+yp*yp+zp*zp,.5); 
if((fabs(y)<1.5)&&(fabs(x)<.4)&&(fabs(z)<.4)) 
 {tcalc=0;
  coll=1;
  //printf("collision v=%lf x=%lf y=%lf cons=%d \n",v,x,y,pc);
 if((fabs(y+1.5)<.1)&&(fabs(x)<.1)&&(fabs(z)<.1))
   {coll=2;  
     if(v<0.12){coll=3;  }
     }
    }
    
    if((x*x+y*y+z*z)>10000){coll=4;} //lost in space  
}

// DrawGLScene ---------------------------------------------------------------
GLvoid DrawGLScene(GLvoid)
{ int i;
  static float zo,yo,xo;  
  extern double *x,*y;
  extern  parametres para_phy;
     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear The Screen And The Depth Buffer
	             						 	// Reset The View    
     glLoadIdentity();      
     drawjau(Xp,Yp,Zp);
     aide(X,Y,Z,Xp,Yp,Zp);
     if (look==1){ // on regarde par dessus l epaule !
     gluLookAt(X+0.75,Y+2.5,Z+1,0,0,0-1,0,0,1);}//gluLookAt(X,Y+5,Z,X,Y+10,Z-1,0,0,1);
      else{
     if(rot==1){ 
      glTranslatef(0.0,0.0,-sdepth); 
      glRotatef(spin_y, 1, 0, 0);
      glRotatef(spin_x, 0, 0, 1);}
       else{  
      glTranslatef(-spin_x/10,spin_y/10,-sdepth);}}
  
     
// les objets
    glLightfv(GL_LIGHT0, GL_POSITION, pos);
    glLightfv(GL_LIGHT0, GL_AMBIENT, lKa);//
    glLightfv(GL_LIGHT0, GL_DIFFUSE, lKd);//
    glLightfv(GL_LIGHT0, GL_SPECULAR, lKs);//
      // glEnable(GL_LIGHTING);
      // glEnable(GL_LIGHT0);
	  
       drawmodel(X,Y,Z);
       drawmodel2(0, 0,0);
       collision(X,Y,Z,Xp,Yp,Zp); 
	
   glDisable(GL_LIGHTING);
   // on eteind  verifer sur PC
   // on remet une Lampe
    
   //lamp();
  glBegin(GL_LINE_STRIP);
  //MateriauP(); 
 
  xo=x[para_phy.nx-1];
  yo=y[para_phy.nx-1];
  zo=z[para_phy.nx-1];
  for(i=para_phy.nx-2;i>0;i--){ //suivant altitude couleurs bleu blanc rouge
if(fabs(z[i])<.2) glColor3ub(255, 255, 255);
if(z[i]>.2)       glColor3ub(255, 0, 0);
if(z[i]<-.2)      glColor3ub(0, 0, 255); 
  glVertex3f(xo,yo-1,zo);
  glVertex3f(x[i],y[i]-1,z[i]);
  zo=z[i];
  yo=y[i];
  xo=x[i]; 
  } 
  glEnd();

    glutSwapBuffers();
    glutPostRedisplay(); //This make sure the glut scene draws correctly before it is resized...im sure
                         // There is a better way of doing it, anyone?
    glFlush();

}
void
idleFunc(void)
{ static int it=0;
  extern int pause,slow;
  
  if(!pause){
  it=it+1;
  if((it%slow)==0){ nextD();/*printf(" %d %d %d \n",it,slow,it%slow);*/}
  }

}
//----------------------------------
void 
GlutLoop(int  *argc, char** argv ){
int ktouf,kmod;
    glutInit( argc,argv);
    raz();
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
    glutInitWindowSize (kWindowWidth, kWindowHeight); 
    glutInitWindowPosition (0, 0);
    glutCreateWindow ("Hill~PYL *  * *    *  * *RendezVousSpatial* *  * * OpenGL");	
    InitGL();
 
    glutDisplayFunc(DrawGLScene); 
    glutReshapeFunc(ReSizeGLScene); 
    glutMotionFunc(motion);
    glutMouseFunc(mouse); 
    glutKeyboardFunc(Keyboard);
    glutSpecialFunc(parsekey_special);
    glutIdleFunc(idleFunc);
    // creation des menus et sous menus....
    ktouf=glutCreateMenu(M_menu_select); 
    glutAddMenuEntry("cas simple:     Omega=0.5, en rattrapage!",0);
    glutAddMenuEntry("cas simple:     Omega=0.10, dans le plan, dans l'axe!",1);
    glutAddMenuEntry("cas assez dur: Omega=0.25, dans le plan, dans l'axe!",2);
    glutAddMenuEntry("cas assez dur: Omega=0.25, hors le plan, dans l'axe!",3);
    glutAddMenuEntry("cas assez dur: Omega=0.25, dans le plan, hors l'axe!",4); 
    glutAddMenuEntry("cas dur  dur: Omega=0.25, hors du plan et de l'axe!",5);   
    kmod=glutCreateMenu(M_model_select); 
    glutAddMenuEntry("gemini gemini",0);
    glutAddMenuEntry("apollo soyouz",1);       
    glutAddMenuEntry("soyouz apollo",2);       
    glutAddMenuEntry("chasseur cible",3);        
    mainMenu = glutCreateMenu(setMain);
    glutAddMenuEntry("Remise `a z'ero compl`ete", 0);
    glutAddSubMenu("cas initiaux ",ktouf);
    glutAddSubMenu("rencontres ",kmod); 
    glutAddMenuEntry("[k] raz Kul en cours", 3);
    glutAddMenuEntry("[v] raz vue", 4);
    glutAddMenuEntry("[r] vue en rotation", 1);
    glutAddMenuEntry("[t] vue en translation", 2);
    glutAddMenuEntry("[l] vue du chasseur/vue paysage",5);
    glutAddMenuEntry("[h] aide", 6);
    glutAddMenuEntry("[Esc] Exit", 7);
    glutAttachMenu(GLUT_RIGHT_BUTTON);
    glutMainLoop(); 
    }



 void init(int  *argc, char** argv)
 {char nomdupgm[256];
  strcpy(nomdupgm,"rdvs");
  strcpy(nomdupgm,"rdvspatial");
  strcpy(nomdupgm,"rdvs.exe");
  printf("on est ici: argv[0]-> %s  \n",argv[0]); 
  nomfichier="data/fo.in";
  nomchasseur="data/gemini_final.obj";
  nomcible="data/geminiB.obj";
 // strncpy(ici,argv[0],strlen(argv[0])-strlen(nomdupgm));
printf("------------------------------------------------------------------------\n");   
printf("                                                                        \n");
printf("      RendezVousSpatial                                                 \n");   
printf("                                                                        \n");
printf(" Resolution des equations de Hill CLOHESSY-WILTSHIRE                    \n");
printf("  2                               2                   2                 \n");
printf(" d x            dy           2   d y            dx   d z          2     \n");
printf(" --- = 2 Omega  -- + 3  Omega x; --- = -2 Omega --;  --- = - Omega z    \n");
printf("   2            dt                 2            dt     2                \n");
printf(" dt                              dt                  dz                 \n");
printf("------------------------------------------------------------------------\n");
printf(" par pyl@ccr.jussieu.fr - www.lmm.jussieu.fr/~lagree                    \n");
printf("------------------------------------------------------------------------\n"); 
printf(" changer cible.obj et chasseur.obj                                      \n");
printf(" images Soyouz et Gemini de Sophie Michaut  - Palais de la Decouverte   \n");  
printf("------------------------------------------------------------------------\n");  
     }


void Lit2(char* fic,parametres * pParaphy)
 {  FILE *g;
    int fi;
    double ff; 
    printf("fichier de donnees:   %s!   \n",fic);
    /* open the file */
    g = fopen(fic, "r");
    if(!g){
        fprintf(stderr, ": pas de fichier  \"%s\".\n",fic);
        //exit(1);
        }else{
  fscanf(g,"dt=%lf              \n",&ff);pParaphy->dt=ff; 
  fscanf(g,"nx=%i               \n",&fi);pParaphy->nx=fi; 
  fscanf(g,"trois=%lf           \n",&ff);pParaphy->trois=ff;  
  fscanf(g,"Omega=%lf           \n",&ff);pParaphy->Omega=ff; 
  fscanf(g,"X0=%lf              \n",&ff);pParaphy->X0=ff; 
  fscanf(g,"Y0=%lf              \n",&ff);pParaphy->Y0=ff;
  fscanf(g,"Z0=%lf              \n",&ff);pParaphy->Z0=ff;
  fscanf(g,"Xp0=%lf             \n",&ff);pParaphy->Xp0=ff; 
  fscanf(g,"Yp0=%lf             \n",&ff);pParaphy->Yp0=ff; 
  fscanf(g,"Zp0=%lf             \n",&ff);pParaphy->Zp0=ff;
  fscanf(g,"p=%lf               \n",&ff);pParaphy->p=ff;
  pParaphy->spe=0;
  if(ff<0){pParaphy->spe=1;pParaphy->p=fabs(ff);printf("Attention special\n");}
  fclose(g);}
  return ; 
 }
 
	   
void raz()
{ static double initial=1;
  int i;
  extern int pc;
  extern  parametres para_phy;
  extern double *x,*y;
 X=0;
 Y=-8;
 Z=0;
 Xp=0;
 Yp=.0;
 Zp=0;
 px=0;
 py=0;
 pz=0;
 //p=2;
 pc=pcmax;
 tcalc=0.05;
 it_t=0;
 coll=0;
  para_phy.dt=0.005;
   para_phy.p=2; 
  Lit2(nomfichier,&para_phy);
  X=para_phy.X0;
  Y=para_phy.Y0;
  Z=para_phy.Z0;
  Xp=para_phy.Xp0;
  Yp=para_phy.Yp0;
  Zp=para_phy.Zp0;
  para_phy.dt=para_phy.dt*speed;
  if (initial==1){
  initial=0;
  x =(double*)calloc(para_phy.nx+1,sizeof(double));
  y =(double*)calloc(para_phy.nx+1,sizeof(double));
  z =(double*)calloc(para_phy.nx+1,sizeof(double));}
  else{
  free(x);
  free(y);
  free(z);
  x =(double*)calloc(para_phy.nx+1,sizeof(double));
  y =(double*)calloc(para_phy.nx+1,sizeof(double));
  z =(double*)calloc(para_phy.nx+1,sizeof(double));
  }
  for  (i=0;i<=para_phy.nx;i++)
	{    x[i]=X;y[i]=Y;z[i]=Z;}
}	   
	   
/*-----------------------------------------------------------------------*/	   
int main(int argc, char** argv)
{  
 init(&argc, argv);  
 GlutLoop(&argc,argv);
 return 0;
}
